angular.module('beamng.apps')
.directive('powerglowEffects', ['bngApi', function (bngApi) {
  return {
	templateUrl: 'modules/apps/PowerglowEffects/app.html',
    replace: true,
    restrict: 'EA',
	scope: true,
	controller: ['$scope', 'bngApi', function ($scope, bngApi) {
		$scope.displayMode = {};
        $scope.modes = [
		    {"id": 1, "mode": "Disabled"},
			{"id": 2, "mode": "Rainbow"}
		];

		$scope.updateMode = function(displayMode) {
			console.log(displayMode);
			if(displayMode == "Disabled") {
				clearInterval(rainbowEffect);
			}
			if(displayMode == "Rainbow") {
				var colors = ["red", "orange", "yellow", "green", "cyan", "blue", "purple"];
				var currentIndex = 0;

				rainbowEffect = setInterval(function() {
					bngApi.engineLua( 'TorqueScript.eval(string.format([[setVehicleColorPalette(0,"' + colors[currentIndex] + '");]]));' );
					currentIndex++;
					if (currentIndex == undefined || currentIndex >= colors.length) {
						currentIndex = 0;
					}
				}, 50);
			}
		};
		
    }],
  };
}]);